unit uFrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    Splitter1: TSplitter;
    lstbxMatches: TListBox;
    mTexto: TMemo;
    edtRegExp: TLabeledEdit;
    btbnPesquisar: TBitBtn;
    spdbtnAbrir: TSpeedButton;
    spdbtnSalvar: TSpeedButton;
    opndlgAbrir: TOpenDialog;
    svdlgSalvar: TSaveDialog;
    chkbxCaseSensitive: TCheckBox;
    btbnSubstituir: TBitBtn;
    procedure spdbtnAbrirClick(Sender: TObject);
    procedure spdbtnSalvarClick(Sender: TObject);
    procedure btbnPesquisarClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lstbxMatchesClick(Sender: TObject);
    procedure btbnSubstituirClick(Sender: TObject);
  private
    procedure LimparLista;
  public
  end;


var
  Form1: TForm1;

implementation

uses VBScript_RegExp_55_TLB, uClassDefs;

{$R *.dfm}

procedure TForm1.spdbtnAbrirClick(Sender: TObject);
begin
  if opndlgAbrir.Execute then begin
    mTexto.Lines.LoadFromFile(opndlgAbrir.FileName);
    StatusBar1.SimpleText := opndlgAbrir.FileName;
  end;
end;

procedure TForm1.spdbtnSalvarClick(Sender: TObject);
begin
  if svdlgSalvar.Execute then begin
    mTexto.Lines.SaveToFile(svdlgSalvar.FileName);
    StatusBar1.SimpleText := svdlgSalvar.FileName;
  end;
end;

//URLs   = (FTP|HTTP)://([_a-z\d\-]+(\.[_a-z\d\-]+)+)((/[ _a-z\d\-\\\.]+)+)*
//Emails = \b[A-Z0-9._%-]+@[A-Z0-9._%-]+\.[A-Z]{2,4}\b
//Emails (nome/dominio) = \b([A-Z0-9._%-]+)@([A-Z0-9._%-]+\.[A-Z]{2,4})\b
//Tags Http/XML (InnerText) = <([^>]+)>
//nomes com extenso txt ou exe = \b([_a-z0-9]+)\.(txt|exe)
//1 seguido de digitos de 0..9 = 1[0-9]+


procedure TForm1.btbnPesquisarClick(Sender: TObject);
var
  i, j : integer;
  ARegExp : RegExp;  //uses VBScript_RegExp_55_TLB !!
  ColecaoAcertos : MatchCollection;
  Acerto : TAcerto;
begin
  try
    Screen.Cursor := crHourGlass;
    ARegExp := CoRegExp.Create;
    with ARegExp do begin
      //a Expresso Regular
      Pattern := edtRegExp.Text;
      {if not ARegExp.Test(mTexto.Text) or (Pattern = '') then
        raise Exception.Create('Expresso incorreta');}
      //IgnoreCase: case sensitive/insensitive
      IgnoreCase := not chkbxCaseSensitive.Checked;
      //Global: Todas as ocorrncias
      Global := True;
      //executa a pesquisa
      ColecaoAcertos := Execute(mTexto.Text) as MatchCollection;
    end;
    LimparLista;
    for i := 0 to ColecaoAcertos.Count - 1 do begin
      //listagem dos acertos
      Acerto := TAcerto.Create(ColecaoAcertos.Item[i] as Match);
      lstbxMatches.Items.AddObject(Acerto.Texto, Acerto);
      for j := 0 to Acerto.SubAcertos.Count - 1 do
        //listagem de subacertos
        lstbxMatches.items.add(
          format('%4s$%d=', ['', j + 1]) +
          VarToStr(Acerto.SubAcertos.Item[j]) );
    end;
  finally
    ARegExp := nil;
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.LimparLista;
var
  i : integer;
begin
  //destri cada objeto TAcerto armazenado na lista
  for i := 0 to lstbxMatches.Count - 1 do
    if lstbxMatches.Items.Objects[i] <> nil then
      lstbxMatches.Items.Objects[i].Free;
  //limpa o listbox
  lstbxMatches.Clear;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  LimparLista;
end;

procedure TForm1.lstbxMatchesClick(Sender: TObject);
var
  OAcerto : TAcerto;
begin
  //se um item estiver selecionado
  OAcerto := lstbxMatches.Items.Objects[lstbxMatches.ItemIndex] as TAcerto;
  if OAcerto <> nil then
  begin
    //seleciona o texto correspondente no memo
    mTexto.SelStart  := OAcerto.Posicao;
    mTexto.SelLength := OAcerto.Tamanho;
    mTexto.SetFocus;
  end;
end;

procedure TForm1.btbnSubstituirClick(Sender: TObject);
var
  ARegExp : RegExp;  //uses VBScript_RegExp_55_TLB !!
begin
  try
    Screen.Cursor := crHourGlass;
    ARegExp := CoRegExp.Create;
    with ARegExp do begin
      Pattern := edtRegExp.Text;
      {if not ARegExp.Test(mTexto.Text) or (Pattern = '') then
        raise Exception.Create('Expresso incorreta');}
      IgnoreCase := not chkbxCaseSensitive.Checked;
      Global := True;
      mTexto.Text := Replace(mTexto.Text,
        InputBox('Substituir resultados', 'Texto', ''));
    end;
  finally
    ARegExp := nil;
    Screen.Cursor := crDefault;
    MessageDlg('Operao finalizada', mtInformation, [mbOk], 0);
  end;
end;

end.
