unit CustomEntityE;

interface

uses
  SysUtils, Classes, FMTBcd, Provider, SqlExpr, DB, DBClient;

type
  TCustomEntity = class(TDataModule)
    DataSource: TDataSource;
    ClientDataSet: TClientDataSet;
    DataSetProvider: TDataSetProvider;
    SQLQuery: TSQLQuery;
    procedure ClientDataSetBeforePost(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CustomEntity: TCustomEntity;

implementation

{$R *.dfm}

procedure TCustomEntity.ClientDataSetBeforePost(DataSet: TDataSet);
var
  //Varivel utilizada para catalogar os campos requeridos no preenchidos
  RequiredFieldsNotFill: TStringList;
  //Varivel utilizada para montar a menssagem de erro
  ErrorMessage: String;
  C: Integer;
begin
  RequiredFieldsNotFill := TStringList.Create;

  //Este lao varre todos os campos
  for C := 0 to DataSet.FieldCount - 1 do
    begin
    //Cataloga os campos requeridos no preenchidos
    if DataSet.Fields[C].Required then
     //Pergunta se o campo est preenchido. Se no estiver adiciona em RequiredFieldsNotFill.
      if (DataSet.Fields[C].IsNull) or (DataSet.Fields[C].AsString = '') then
        RequiredFieldsNotFill.Add(DataSet.Fields[C].DisplayLabel);
    end;

  //Crtica para campos requeridos no preenchidos
  if RequiredFieldsNotFill.Count > 0 then
    begin
    ErrorMessage := ' necessrio que o(s) campo(s) "';
    for C := 0 to RequiredFieldsNotFill.Count - 1 do
      begin
      if C = RequiredFieldsNotFill.Count-1 then // o ltimo
        begin
        if RequiredFieldsNotFill.Count = 1 then // o nico
          ErrorMessage := ErrorMessage + RequiredFieldsNotFill[C]
        else // Se no for o nico bota um "e" antes
          ErrorMessage := ErrorMessage + ' e '+RequiredFieldsNotFill[C]
        end
      else //Se nao for o ltimo
        begin
        ErrorMessage := ErrorMessage + RequiredFieldsNotFill[C];
        //Se nao for o penltimo bota vrgula depois
        if C < RequiredFieldsNotFill.Count-2 then ErrorMessage := ErrorMessage + ', ';
        end;
      end;
    ErrorMessage := ErrorMessage + '" seja(m) preenchido(s) em ' + Name+'!';
    Raise Exception.Create(ErrorMessage);
    end;
end;

end.
