unit UVENDA;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Tabnotbk, Mask, StdCtrls, Buttons, ExtCtrls,db, UObjVENDA,
  jpeg;

type
  TFVENDA = class(TForm)
    Guia: TTabbedNotebook;
    Image1: TImage;
    Btnovo: TBitBtn;
    btpesquisar: TBitBtn;
    btrelatorios: TBitBtn;
    btalterar: TBitBtn;
    btgravar: TBitBtn;
    btexcluir: TBitBtn;
    btsair: TBitBtn;
    btcancelar: TBitBtn;
    Label1: TLabel;
    Edit1: TEdit;
    LbCODIGO: TLabel;
    EdtCODIGO: TEdit;
    LbCliente: TLabel;
    EdtCliente: TEdit;
    LbValor: TLabel;
    EdtValor: TEdit;
//DECLARA COMPONENTES

    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BtnovoClick(Sender: TObject);
    procedure btalterarClick(Sender: TObject);
    procedure btgravarClick(Sender: TObject);
    procedure btexcluirClick(Sender: TObject);
    procedure btcancelarClick(Sender: TObject);
    procedure btsairClick(Sender: TObject);
    procedure btpesquisarClick(Sender: TObject);
  private
         Function  ControlesParaObjeto:Boolean;
         Function  ObjetoParaControles:Boolean;
         Function  TabelaParaControles:Boolean;
         Procedure LimpaLabels;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FVENDA: TFVENDA;
  ObjVENDA:TObjVENDA;

implementation

uses Uessencial, Upesquisa;



{$R *.DFM}
//****************************************
//*************MANIPULACAO DO OBJETO******
//****************************************
function TFVENDA.ControlesParaObjeto: Boolean;
Begin
  Try
    With ObjVENDA do
    Begin
        Submit_CODIGO(edtCODIGO.text);
        Submit_Cliente(edtCliente.text);
        Submit_Valor(edtValor.text);
//CODIFICA SUBMITS


         result:=true;
    End;
  Except
        result:=False;
  End;
End;

function TFVENDA.ObjetoParaControles: Boolean;
Begin
  Try
     With ObjVENDA do
     Begin
        EdtCODIGO.text:=Get_CODIGO;
        EdtCliente.text:=Get_Cliente;
        EdtValor.text:=Get_Valor;
//CODIFICA GETS

      
        result:=True;
     End;
  Except
        Result:=False;
  End;
End;

function TFVENDA.TabelaParaControles: Boolean;
begin
     If (ObjVENDA.TabelaparaObjeto=False)
     Then Begin
                result:=False;
                exit;
          End;
     If (ObjetoParaControles=False)
     Then Begin
                result:=False;
                exit;
          End;
     Result:=True;
end;



//****************************************
procedure TFVENDA.FormActivate(Sender: TObject);
begin
     limpaedit(Self);
     Self.limpaLabels;
     desabilita_campos(Self);
     Guia.PageIndex:=0;

     Try
        ObjVENDA:=TObjVENDA.create;
     Except
           Messagedlg('Erro na Inicializao do Objeto !',mterror,[mbok],0);
           Self.close;
     End;
     PegaFiguraBotoes(btnovo,btalterar,btcancelar,btgravar,btpesquisar,btrelatorios,btexcluir,btsair);
end;

procedure TFVENDA.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     If (ObjVENDA=Nil)
     Then exit;

If (ObjVENDA.status<>dsinactive)
Then Begin
          Messagedlg('No  possvel Finalizar antes de Cancelar ou Salvar as Alteraes!',mterror,[mbok],0);
          abort;
          exit;
     End;

ObjVENDA.free;
end;

procedure TFVENDA.FormKeyPress(Sender: TObject; var Key: Char);
begin
      if key=#13
      Then Perform(Wm_NextDlgCtl,0,0);
end;



procedure TFVENDA.BtnovoClick(Sender: TObject);
begin
     limpaedit(Self);
     Self.limpaLabels;
     habilita_campos(Self);
     desab_botoes(Self);

     //edtcodigo.text:='0';
     edtcodigo.text:=ObjVENDA.Get_novocodigo;
     edtcodigo.enabled:=False;

     
     Btgravar.enabled:=True;
     BtCancelar.enabled:=True;
     btpesquisar.enabled:=True;

     ObjVENDA.status:=dsInsert;
     Guia.pageindex:=0;
     EdtPrimeiro.setfocus;

end;


procedure TFVENDA.btalterarClick(Sender: TObject);
begin
    If (ObjVENDA.Status=dsinactive) and (EdtCodigo.text<>'')
    Then Begin
                habilita_campos(Self);
                EdtCodigo.enabled:=False;
                ObjVENDA.Status:=dsEdit;
                guia.pageindex:=0;
                edtPrimeiro.setfocus;
                desab_botoes(Self);
                Btgravar.enabled:=True;
                BtCancelar.enabled:=True;
                btpesquisar.enabled:=True;
          End;


end;

procedure TFVENDA.btgravarClick(Sender: TObject);
begin

     If ObjVENDA.Status=dsInactive
     Then exit;

     If ControlesParaObjeto=False
     Then Begin
               Messagedlg('Erro na tentativa de Transferir os Dados dos Edits para o Objeto!',mterror,[mbok],0);
               exit;
          End;

     If (ObjVENDA.salvar=False)
     Then exit;

     habilita_botoes(Self);
     limpaedit(Self);
     Self.limpaLabels;
     desabilita_campos(Self);
     Messagedlg('Os Dados foram Salvos com Sucesso!',mtinformation,[mbok],0);

end;

procedure TFVENDA.btexcluirClick(Sender: TObject);
begin
     If (ObjVENDA.status<>dsinactive) or (Edtcodigo.text='')
     Then exit;

     If (ObjVENDA.LocalizaCodigo(edtcodigo.text)=False)
     Then Begin
               Messagedlg('Registro no localizado para ser excludo!',mterror,[mbok],0);
               exit;
          End;

     If (Messagedlg('Certeza que deseja Excluir?',mtconfirmation,[mbyes,mbno],0)=Mrno)
     Then exit;     
     
     If (ObjVENDA.exclui(edtcodigo.text)=False)
     Then Begin
               Messagedlg('Erro Durante a Excluso!!'+#13+'Possveis Causas: Registro bloqueado por outro usurio!',mterror,[mbok],0);
               exit;
          End;
     limpaedit(Self);
     Self.limpaLabels;
     Messagedlg('Excluso Concluda com Sucesso!',mtinformation,[mbok],0);


end;

procedure TFVENDA.btcancelarClick(Sender: TObject);
begin
     ObjVENDA.cancelar;

     limpaedit(Self);
     Self.limpaLabels;
     desabilita_campos(Self);
     habilita_botoes(Self);

end;

procedure TFVENDA.btsairClick(Sender: TObject);
begin
    Close;
end;

procedure TFVENDA.btpesquisarClick(Sender: TObject);
var
   FpesquisaLocal:TFpesquisa;
begin

        Try
           Fpesquisalocal:=Tfpesquisa.create(Self);

            If (FpesquisaLocal.PreparaPesquisa(ObjVENDA.Get_pesquisa,ObjVENDA.Get_TituloPesquisa,Nil)=True)
            Then Begin
                      Try
                        If (FpesquisaLocal.showmodal=mrok)
                        Then Begin
                                  If ObjVENDA.status<>dsinactive
                                  then exit;

                                  If (ObjVENDA.LocalizaCodigo(FpesquisaLocal.QueryPesq.fieldbyname('codigo').asstring)=False)
                                  Then Begin
                                            Messagedlg('Dados no encontrados!',mterror,[mbok],0);
                                            exit;
                                       End;
                                  ObjVENDA.ZERARTABELA;
                                  If (TabelaParaControles=False)
                                  Then Begin
                                            Messagedlg('Erro na Transferncia dos Dados!',mterror,[mbok],0);
                                            limpaedit(Self);
                                            Self.limpaLabels;
                                            exit;
                                       End; 

                             End;
                      Finally
                        FpesquisaLocal.QueryPesq.close;
                      End;
                 End;

        Finally
           FreeandNil(FPesquisaLocal);
        End;


end;


procedure TFVENDA.LimpaLabels;
begin
//LIMPA LABELS
end;

end.
{var
   FpesquisaLocal:Tfpesquisa;
begin

     If (key <>vk_f9)
     Then exit;

     Try
            Fpesquisalocal:=Tfpesquisa.create(Self);
            If (FpesquisaLocal.PreparaPesquisa(ObjVENDA.OBJETO.Get_Pesquisa,ObjVENDA.OBJETO.Get_TituloPesquisa,NOMEDOFORM_OU_NIL)=True)
            Then Begin
                      Try
                        If (FpesquisaLocal.showmodal=mrok)
                        Then Begin
                                 TEdit(Sender).text:=FpesquisaLocal.QueryPesq.fieldbyname(OBJVENDA.objeto.RETORNACAMPOCODIGO).asstring;
                                 If TEdit(Sender).text<>''
                                 Then Begin
                                        If OBJVENDA.objeto.RETORNACAMPONOME<>''
                                        Then Self.Lb.caption:=FpesquisaLocal.QueryPesq.fieldbyname(OBJVENDA.objeto.RETORNACAMPONOME).asstring
                                        Else Self.Lb.caption:='';
                                 End;
                             End;
                      Finally
                             FpesquisaLocal.QueryPesq.close;
                      End;
                  End;

     Finally
           FreeandNil(FPesquisaLocal);
     End;
end;




}
