unit uteste;

interface

uses
  db,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,uobjclientes;

type
  Tfteste = class(TForm)
    Button1: TButton;
    BtTeste02: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure BtTeste02Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fteste: Tfteste;

implementation

uses Uessencial, UObjVENDA;

{$R *.DFM}

procedure Tfteste.Button1Click(Sender: TObject);
var
objclientes:Tobjclientes;
begin
     try
        objclientes:=TObjCLIENTES.create;
     Except
           Messagedlg('Erro na tentativa de instanciar o Objeto de Clientes!',mterror,[mbok],0);
           exit;
     end;

     Try
        With objclientes do
        Begin
             ZerarTabela;//limpando os atributos
             If (LocalizaCodigo('1')=True)//Localizando a Chave Primaria com o valor '1'
             Then Begin
                       TabelaparaObjeto;//transferindo os dados para o Objeto
                       //resgatando os dados do Objeto
                       Showmessage('Cdigo: '+Get_codigo);
                       Showmessage('Nome: '+Get_Nome);
                       Showmessage('Data de Nascimento: '+Get_DataNascimento);
                       Showmessage('Hora Nascimento: '+Get_HoraNascimento);
                       Showmessage('Limite de Compra: '+Get_LimiteCompra);
                       exit;
             End
             Else Begin
                       Messagedlg('Chave no localizada!',mtinformation,[mbok],0);
                       exit;

             End;
        End;
     Finally
          ObjClientes.Free;//liberando o objeto da memria
     End;



end;

procedure Tfteste.BtTeste02Click(Sender: TObject);
var
objclientes:Tobjclientes;
TmpCodigo:Str09;
begin
     try
        objclientes:=TObjCLIENTES.create;
     Except
           Messagedlg('Erro na tentativa de instanciar o Objeto de Clientes!',mterror,[mbok],0);
           exit;
     end;

     Try
        With objclientes do
        Begin
             ZerarTabela;//limpando os atributos

             //***INSERINDO UM DADO*****
             Status:=DsInsert;
             TmpCodigo:=Get_NovoCodigo;//gerando a chave primria
             Submit_Codigo(TmpCodigo);
             Submit_Nome('Ronnei Peterson');
             Submit_DataNascimento('13/03/1980');
             Submit_HoraNascimento('18:00');
             Submit_LimiteCompra('5000,00');
             if (salvar(True)=False)
             Then Begin
                       Messagedlg('Erro durante a Gravao de um novo registro!',mterror,[mbok],0);
                       exit
             End;
             //*****Localizando e Alterando ******

             ZerarTabela;//limpando os atributos
             if (LocalizaCodigo(TmpCodigo)=False)//localizando o registro
             Then Begin
                       Messagedlg('Registro no encontrado!',mterror,[mbok],0);
                       exit;
             End;
             TabelaparaObjeto;//transfere para os atributos
             Status:=dsedit;
             //alterando o limite de compra
             Submit_LimiteCompra('1500,00');
             if (salvar(True)=False)
             Then Begin
                       Messagedlg('Erro durante a alterao de um registro!',mterror,[mbok],0);
                       exit
             End;

             //excluindo os dados

             ZerarTabela;//limpando os atributos
             if (Exclui(TmpCodigo,true)=False)//apagando o registro
             Then Begin
                       Messagedlg('Erro durante a gravao!',mterror,[mbok],0);
                       exit;
             End;

        End;
     Finally
          ObjClientes.Free;//liberando o objeto da memria
     End;



end;

procedure Tfteste.Button2Click(Sender: TObject);
var
ObjVenda:TObjVENDA;
CodigoVenda,CodigoCliente:String;

begin
     try
        ObjVenda:=TObjVENDA.create;
     except
           Messagedlg('Erro na tentativa de Criar o Objeto de Venda!',mtinformation,[mbok],0);
     End;

     try

        Repeat
                CodigoCliente:='';
                if (InputQuery('Cliente','Digite o cdigo do Cliente',codigocliente)=false)
                then exit;
        Until(Codigocliente<>'');

        //gerando uma nova venda
        CodigoVenda:=ObjVenda.Get_NovoCodigo;
        ObjVenda.Status:=dsInsert;
        ObjVenda.Submit_CODIGO(CodigoVenda);
        ObjVenda.Submit_Valor('200');
        ObjVenda.Cliente.Submit_Codigo(CodigoCliente);
        if (ObjVenda.Salvar(True)=False)
        Then Begin
                  MessageDlg('No foi possvel gerar a venda!',mterror,[mbok],0);
                  exit;
        End;
        Messagedlg('Venda gerada Com Sucesso'+#13+'N venda '+CodigoVenda,mtInformation,[mbok],0);

        ObjVenda.ZerarTabela;
        ObjVenda.LocalizaCodigo(CodigoVenda);
        ObjVenda.TabelaparaObjeto;
        Messagedlg('Dados da Venda:'+#13+
                   'Codigo  : '+ObjVenda.Get_CODIGO+#13+
                   'Valor   : '+ObjVenda.Get_Valor+#13+
                   'Cliente : '+ObjVenda.Cliente.Get_Codigo+#13+
                   'Nome Cliente    : '+ObjVenda.Cliente.Get_Nome+#13+
                   'Data Nascimento : '+ObjVenda.Cliente.Get_DataNascimento+#13+
                   'Hora Nascimento : '+ObjVenda.Cliente.Get_HoraNascimento+#13+
                   'Limite de Compra: '+ObjVenda.Cliente.Get_LimiteCompra,mtInformation,[mbok],0);

     Finally
            ObjVenda.free;
     End;

end;

end.
