unit uClientes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFrmClientes = class(TForm)
    GroupBox1: TGroupBox;
    lblCodigo: TLabel;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    EdtNome: TEdit;
    EdtEndereco: TEdit;
    Label4: TLabel;
    GroupBox3: TGroupBox;
    btnPrimeiro: TBitBtn;
    btnAnterior: TBitBtn;
    BtnProximo: TBitBtn;
    BtnUltimo: TBitBtn;
    GroupBox4: TGroupBox;
    btnConfirmar: TBitBtn;
    BtnCancelar: TBitBtn;
    GroupBox5: TGroupBox;
    btnIncluir: TBitBtn;
    btnAlterar: TBitBtn;
    BtnExcluir: TBitBtn;
    GroupBox6: TGroupBox;
    btnRetornar: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure btnRetornarClick(Sender: TObject);
    procedure btnPrimeiroClick(Sender: TObject);
    procedure btnAnteriorClick(Sender: TObject);
    procedure BtnProximoClick(Sender: TObject);
    procedure BtnUltimoClick(Sender: TObject);
    procedure btnIncluirClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure btnConfirmarClick(Sender: TObject);
    procedure BtnExcluirClick(Sender: TObject);
    procedure BtnCancelarClick(Sender: TObject);

  private
    { Private declarations }
    procedure ExibirClientes;
    procedure LimparEdits;
    procedure EmOperacao;
    procedure ForadeOperacao;
  public
    { Public declarations }
  end;

var
  FrmClientes: TFrmClientes;
  _CodCliente: string;
  _Operacao: string;

implementation

uses uDataModule;

{$R *.dfm}

procedure TFrmClientes.ExibirClientes;
begin
  lblCodigo.Caption := DataModule1.cdsClientes.fieldbyname('NUMERO_CLIENTE').AsString;
  EdtNome.Text := DataModule1.cdsClientes.fieldbyname('NOME_CLIENTE').AsString;
  EdtEndereco.Text := DataModule1.cdsClientes.fieldbyname('END_CLIENTE').AsString;
end;

procedure TFrmClientes.FormCreate(Sender: TObject);
begin
  DataModule1.cdsClientes.Close;
  DataModule1.cdsClientes.CommandText := 'SELECT * FROM CLIENTES ORDER BY NUMERO_CLIENTE';
  DataModule1.cdsClientes.Open;
  ExibirClientes;
end;

procedure TFrmClientes.btnRetornarClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmClientes.btnPrimeiroClick(Sender: TObject);
begin
  if not DATAMODULE1.cdsClientes.Bof then datamodule1.cdsClientes.First;
  ExibirClientes;
end;

procedure TFrmClientes.btnAnteriorClick(Sender: TObject);
begin
  if not DATAMODULE1.cdsClientes.Bof then datamodule1.cdsClientes.Prior;
  ExibirClientes;
end;

procedure TFrmClientes.BtnProximoClick(Sender: TObject);
begin
  if not DATAMODULE1.cdsClientes.eof then datamodule1.cdsClientes.Next;
  ExibirClientes;

end;

procedure TFrmClientes.BtnUltimoClick(Sender: TObject);
begin
  if not DATAMODULE1.cdsClientes.eof then
    datamodule1.cdsClientes.Last;
  ExibirClientes;
end;

procedure TFrmClientes.btnIncluirClick(Sender: TObject);
begin
  _CodCliente := '';
  _Operacao := 'I'; // Inclusao;
  LimparEdits;
  EmOperacao;
end;

procedure TFrmClientes.btnAlterarClick(Sender: TObject);
begin
  _CodCliente := DataModule1.cdsClientesNUMERO_CLIENTE.AsString;
  _Operacao := 'A'; // Alteracao;
  EmOperacao;
end;

procedure TFrmClientes.EmOperacao;
begin
  btnPrimeiro.Enabled := False;
  BtnProximo.Enabled := False;
  btnAnterior.Enabled := False;
  BtnUltimo.Enabled := False;
  BtnCancelar.Enabled := True;
  btnConfirmar.Enabled := True;
  btnRetornar.Enabled := False;
  EdtNome.Enabled := True;
  EdtEndereco.Enabled := True;
  btnIncluir.Enabled := False;
  btnAlterar.Enabled := False;
  BtnExcluir.Enabled := False;
end;

procedure TFrmClientes.ForadeOperacao;
begin
  btnPrimeiro.Enabled := True;
  BtnProximo.Enabled := True;
  btnAnterior.Enabled := True;
  BtnUltimo.Enabled := True;
  BtnCancelar.Enabled := False;
  btnConfirmar.Enabled := False;
  btnRetornar.Enabled := True;
  EdtNome.Enabled := False;
  EdtEndereco.Enabled := False;
  btnIncluir.Enabled := True;
  btnAlterar.Enabled := True;
  BtnExcluir.Enabled := True;
end;

procedure TFrmClientes.LimparEdits;
begin
  EdtNome.Text := '';
  EdtEndereco.Text := '';
  lblCodigo.Caption := '000';
end;

procedure TFrmClientes.btnConfirmarClick(Sender: TObject);
begin
  DataModule1.cdsTemp.Active := false;
  if _Operacao = 'I' then
  begin
    DataModule1.cdsTemp.CommandText := 'INSERT INTO CLIENTES (NOME_CLIENTE, END_CLIENTE) VALUES (:NOME_CLIENTE,:END_CLIENTE)';
    DataModule1.cdsTemp.Params.ParamByName('NOME_CLIENTE').AsString := EdtNome.Text;
    DataModule1.cdsTemp.Params.ParamByName('END_CLIENTE').AsString := EdtEndereco.Text;
  end;
  if _Operacao = 'A' then
  begin
    DataModule1.cdsTemp.CommandText := 'UPDATE CLIENTES SET NOME_CLIENTE=:NOME_CLIENTE,END_CLIENTE=:END_CLIENTE WHERE NUMERO_CLIENTE = :NUMERO_CLIENTE';
    DataModule1.cdsTemp.Params.ParamByName('NOME_CLIENTE').AsString := EdtNome.Text;
    DataModule1.cdsTemp.Params.ParamByName('END_CLIENTE').AsString := EdtEndereco.Text;
    DataModule1.cdsTemp.Params.ParamByName('NUMERO_CLIENTE').AsString := _CodCliente;
  end;
  if _Operacao = 'E' then
  begin
    DataModule1.cdsTemp.CommandText := 'DELETE FROM CLIENTES WHERE NUMERO_CLIENTE = :NUMERO_CLIENTE';
    DataModule1.cdsTemp.Params.ParamByName('NUMERO_CLIENTE').AsString := _CodCliente;
  end;
  DataModule1.cdsTemp.Execute;
  DataModule1.cdsClientes.Refresh;
  ExibirClientes;
  _Operacao := '';
  ForadeOperacao;
end;

procedure TFrmClientes.BtnExcluirClick(Sender: TObject);
begin
  _CodCliente := DataModule1.cdsClientesNUMERO_CLIENTE.AsString;
  _Operacao := 'E';
  EmOperacao;
end;

procedure TFrmClientes.BtnCancelarClick(Sender: TObject);
begin
  ExibirClientes;
  _Operacao := '';
  ForadeOperacao;
end;

end.

