unit uFrmFamiliaProduto;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFrmFamiliaProduto = class(TForm)
    GroupBox1: TGroupBox;
    lblCodigo: TLabel;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    EdtNome: TEdit;
    GroupBox3: TGroupBox;
    btnPrimeiro: TBitBtn;
    btnAnterior: TBitBtn;
    BtnProximo: TBitBtn;
    BtnUltimo: TBitBtn;
    GroupBox4: TGroupBox;
    btnConfirmar: TBitBtn;
    BtnCancelar: TBitBtn;
    GroupBox5: TGroupBox;
    btnIncluir: TBitBtn;
    btnAlterar: TBitBtn;
    BtnExcluir: TBitBtn;
    GroupBox6: TGroupBox;
    btnRetornar: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure btnRetornarClick(Sender: TObject);
    procedure btnPrimeiroClick(Sender: TObject);
    procedure btnAnteriorClick(Sender: TObject);
    procedure BtnProximoClick(Sender: TObject);
    procedure BtnUltimoClick(Sender: TObject);
    procedure btnIncluirClick(Sender: TObject);
    procedure btnAlterarClick(Sender: TObject);
    procedure BtnExcluirClick(Sender: TObject);
    procedure btnConfirmarClick(Sender: TObject);
  private
    { Private declarations }
    procedure Exibirfamilias;
    procedure LimparEdits;
    procedure EmOperacao;
    procedure ForadeOperacao;
  public
    { Public declarations }
  end;

var
  FrmFamiliaProduto: TFrmFamiliaProduto;
  _CodFamilia: string;
  _Operacao: string;

implementation

uses uDataModule;

{$R *.dfm}

{ TForm1 }

procedure TFrmFamiliaProduto.EmOperacao;
begin
  btnPrimeiro.Enabled := False;
  BtnProximo.Enabled := False;
  btnAnterior.Enabled := False;
  BtnUltimo.Enabled := False;
  BtnCancelar.Enabled := True;
  btnConfirmar.Enabled := True;
  btnRetornar.Enabled := False;
  EdtNome.Enabled := True;
  btnIncluir.Enabled := False;
  btnAlterar.Enabled := False;
  BtnExcluir.Enabled := False;
end;

procedure TFrmFamiliaProduto.Exibirfamilias;
begin
  lblCodigo.Caption := DataModule1.cdsFamiliaProduto.fieldbyname('FAMILIA_PRODUTO').AsString;
  EdtNome.Text := DataModule1.cdsFamiliaProduto.fieldbyname('DESCR_FAMILIA').AsString;

end;

procedure TFrmFamiliaProduto.ForadeOperacao;
begin
  btnPrimeiro.Enabled := True;
  BtnProximo.Enabled := True;
  btnAnterior.Enabled := True;
  BtnUltimo.Enabled := True;
  BtnCancelar.Enabled := False;
  btnConfirmar.Enabled := False;
  btnRetornar.Enabled := True;
  EdtNome.Enabled := False;

  btnIncluir.Enabled := True;
  btnAlterar.Enabled := True;
  BtnExcluir.Enabled := True;

end;

procedure TFrmFamiliaProduto.LimparEdits;
begin
  EdtNome.Text := '';
  lblCodigo.Caption := '000';
end;

procedure TFrmFamiliaProduto.FormCreate(Sender: TObject);
begin
  DataModule1.cdsFamiliaProduto.Close;
  DataModule1.cdsFamiliaProduto.CommandText := 'SELECT * FROM FAMILIA ORDER BY FAMILIA_PRODUTO';
  DataModule1.cdsFamiliaProduto.Open;
  Exibirfamilias;
end;

procedure TFrmFamiliaProduto.btnRetornarClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmFamiliaProduto.btnPrimeiroClick(Sender: TObject);
begin
  if not DATAMODULE1.cdsFamiliaProduto.Bof then datamodule1.cdsFamiliaProduto.First;
  Exibirfamilias;
end;

procedure TFrmFamiliaProduto.btnAnteriorClick(Sender: TObject);
begin
  if not DATAMODULE1.cdsFamiliaProduto.Bof then datamodule1.cdsFamiliaProduto.Prior;
  Exibirfamilias;
end;

procedure TFrmFamiliaProduto.BtnProximoClick(Sender: TObject);
begin
  if not DATAMODULE1.cdsFamiliaProduto.eof then datamodule1.cdsFamiliaProduto.Next;
  Exibirfamilias;

end;

procedure TFrmFamiliaProduto.BtnUltimoClick(Sender: TObject);
begin
if not DATAMODULE1.cdsFamiliaProduto.eof then
    datamodule1.cdsFamiliaProduto.Last;
  Exibirfamilias;
end;

procedure TFrmFamiliaProduto.btnIncluirClick(Sender: TObject);
begin
  _CodFamilia := '';
  _Operacao := 'I';
  LimparEdits;
  EmOperacao;
end;

procedure TFrmFamiliaProduto.btnAlterarClick(Sender: TObject);
begin
  _CodFamilia := DataModule1.cdsFamiliaProdutoFAMILIA_PRODUTO.AsString;
  _Operacao := 'A'; 
  EmOperacao;
end;

procedure TFrmFamiliaProduto.BtnExcluirClick(Sender: TObject);
begin
  _CodFamilia := DataModule1.cdsFamiliaProdutoFAMILIA_PRODUTO.AsString;
  _Operacao := 'E';
  EmOperacao;
end;

procedure TFrmFamiliaProduto.btnConfirmarClick(Sender: TObject);
begin
  DataModule1.cdsTemp.Active := false;
  if _Operacao = 'I' then
  begin
    DataModule1.cdsTemp.CommandText := 'INSERT INTO FAMILIA (DESCR_FAMILIA) VALUES (:DESCR_FAMILIA)';
    DataModule1.cdsTemp.Params.ParamByName('DESCR_FAMILIA').AsString := EdtNome.Text;
  end;
  if _Operacao = 'A' then
  begin
    DataModule1.cdsTemp.CommandText := 'UPDATE FAMILIA SET DESCR_FAMILIA=:DESCR_FAMILIA WHERE FAMILIA_PRODUTO = :FAMILIA_PRODUTO';
    DataModule1.cdsTemp.Params.ParamByName('DESCR_FAMILIA').AsString := EdtNome.Text;
    DataModule1.cdsTemp.Params.ParamByName('FAMILIA_PRODUTO').AsString := _CodFamilia;
  end;
  if _Operacao = 'E' then
  begin
    DataModule1.cdsTemp.CommandText := 'DELETE FROM FAMILIA WHERE FAMILIA_PRODUTO = :FAMILIA_PRODUTO';
    DataModule1.cdsTemp.Params.ParamByName('FAMILIA_PRODUTO').AsString := _CodFamilia;
  end;
  DataModule1.cdsTemp.Execute;
  DataModule1.cdsFamiliaProduto.Refresh;
  Exibirfamilias;
  _Operacao := '';
  ForadeOperacao;
end;

end.

